/* GPIO Example

   This example code is in the Public Domain (or CC0 licensed, at your option.)

   Unless required by applicable law or agreed to in writing, this
   software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
   CONDITIONS OF ANY KIND, either express or implied.
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/queue.h"
#include "driver/gpio.h"
#include "motors.h"
#include "encoders.h"
#include "hwTimer.h"
#include "control.h"

#define OMNI_CTRL_TIMER 0.05 // s
#define MAX_OUTPUT 100.0
#define NMOTORS 3
#define OMNI_NRO_TIMER 0



static void timer_func() {
    printf("ECHO TIMER \n");
}

void app_main(void)
{

    //1. mcpwm gpio initialization
    motor_h_t *mot;
    
    motor_install(26,27, MCPWM_UNIT_0, MCPWM0A, MCPWM0B, MCPWM_TIMER_0, &mot);
    // pines de los motores 
    //                      Motor 0: 26,27      Encoder 0: 37, 39
    //                      Motor 1: 25,33      Encoder 1: 36, 38
    //                      Motor 2: 18,23      Encoder 2: 34, 35
    //2. initial mcpwm configuration
    printf("Configuring Initial Parameters of mcpwm...\n");
    motor_start(mot);    //Configure PWM0A & PWM0B with above settings


    int inc = 10;
    while (1) {        
        
        motor_set_speed(mot, inc);
        vTaskDelay(2000 / portTICK_RATE_MS);
        motor_stop(mot);
        vTaskDelay(2000 / portTICK_RATE_MS);
        motor_set_speed(mot, -inc);
        vTaskDelay(2000 / portTICK_RATE_MS);
        motor_stop(mot);
        vTaskDelay(2000 / portTICK_RATE_MS);
        
        inc++;
        if (inc == 30){
            inc = 10;
        }
    }
}

