#ifndef VECTOR_MATH_H
#define VECTOR_MATH_H

#include "math.h"

#define PI 3.1415926535897932384626433832795
#define PIdiv180 (PI/180.0)
#define SQR(x) (x*x)
#define SGN(x) (x<0?-1:1)
#define ABS(x) (x<0?-x:x)
#define NULL_VECTOR F3dVector(0.0f,0.0f,0.0f)

/////////////////////////////////
//Note: All angles in degrees  //
/////////////////////////////////

typedef struct {
	float x,y,z;
} sF3dVector_t;

typedef struct {
	float x1,y1,z1,x2,y2,z2,x3,y3,z3;
} sF3dMatrix_t;


float getLength(sF3dVector_t* v);
void normalize(sF3dVector_t* v);


/**
 * v = v + v2
**/
void sum (sF3dVector_t* v, sF3dVector_t v2);

/**
 * v = v - v2
**/

void difference (sF3dVector_t* v, sF3dVector_t v2);

/**
 * v = v*r
**/
void float_mul (sF3dVector_t* v, float r);

/**
 * v = v/r
**/
void float_div (sF3dVector_t* v, float r);

/**
 * ret dot product
**/
float dotProduct (sF3dVector_t* v, sF3dVector_t v2);

/**
 * ret  v = vectorial product
**/
void crossProduct (sF3dVector_t* v, sF3dVector_t v2);

/**
 * v =  M*v
**/
void vector_mul (sF3dMatrix_t m, sF3dVector_t* v);
#endif	/* VECTOR_MATH_H */